﻿using System.Data.Services;
using System.Data.Services.Common;
using DataAccessMSDN;
using System.Data.Entity;
using System.Reflection;
using System.Linq;
using System.Text;

namespace DataServiceApp
{
  public class DataService : DataService<PersonModelContext>
  {
    public static void InitializeService(DataServiceConfiguration config)
    {
      config.UseVerboseErrors = true;
      config.SetEntitySetAccessRule("People", EntitySetRights.All);
      config.DataServiceBehavior.MaxProtocolVersion = DataServiceProtocolVersion.V3;
    }


    protected override void HandleException(HandleExceptionArgs args)
    {
#if false
      if (args.Exception.GetType() ==
          typeof(TargetInvocationException)
          && args.Exception.InnerException != null)
      {
        if (args.Exception.InnerException.GetType()
            == typeof(DataServiceException))
        {

          // Unpack the DataServiceException.
          args.Exception = args.Exception.InnerException as DataServiceException;

        }
        else
        {
          // Return a new DataServiceException as "400: bad request."
          args.Exception =
              new DataServiceException(400,
                  args.Exception.InnerException.Message);
        }
      }
#endif
      if (args.Exception.GetType()== 
        typeof(System.Data.Entity.Validation.DbEntityValidationException))
      {
        var ve=args.Exception as System.Data.Entity.Validation.DbEntityValidationException;
        
        var errorsForOneObject = ve.EntityValidationErrors.First().ValidationErrors.ToList();
        var errorMessage=new StringBuilder();
        foreach (System.Data.Entity.Validation.DbValidationError e in errorsForOneObject)
        {
          errorMessage.AppendLine(e.ErrorMessage);
        }
        args.Exception = new DataServiceException(errorMessage.ToString());
      }
    }
  }
}
